////////////////////////////////////////////////////////////////////////////////
//Code stub generated with:
//                                Crocus Modeller
//                      Robust UML editor for AS3 & Flex devs.
//                             http://CrocusModeller.com
//
////////////////////////////////////////////////////////////////////////////////


package hmartin.socketService.configs {
	import hmartin.socketService.controller.commands.ConnectDeviceCommand;
	import hmartin.socketService.controller.commands.DisconnectDeviceCommand;
	import hmartin.socketService.controller.commands.SendDatasToDeviceCommand;
	import hmartin.socketService.controller.commands.UpdateDeviceConnectionStatusCommand;
	import hmartin.socketService.controller.requests.RequestConnectDevice;
	import hmartin.socketService.controller.requests.RequestDisconnectDevice;
	import hmartin.socketService.controller.requests.RequestSendDatasToDevice;
	import hmartin.socketService.controller.requests.RequestUpdateDeviceConnectionStatus;
	import hmartin.socketService.service.notifications.NotifyDatasReceivedFromDevice;
	import hmartin.socketService.service.notifications.NotifyDatasSentToDevice;
	import hmartin.socketService.service.notifications.NotifyDeviceConnected;
	import hmartin.socketService.service.notifications.NotifyDeviceConnectionStatusUpdated;
	import hmartin.socketService.service.notifications.NotifyDeviceDisconnected;
	import hmartin.socketService.service.notifications.NotifyErrorReceivedFromDevice;
	
	import robotlegs.bender.extensions.signalCommandMap.api.ISignalCommandMap;
	import robotlegs.bender.framework.api.IConfig;
	import robotlegs.bender.framework.api.IContext;
	import robotlegs.bender.framework.api.IInjector;

	/**
	 * hmartin.socketService.config.SocketServiceConfig
	 *
	 * @author Harold MARTIN
	 */
	public class SocketServiceConfig implements IConfig {

		[Inject] public var signalCommandMap:ISignalCommandMap;
		
		[Inject] public var injector:IInjector;
		
		[Inject] public var context:IContext;
		
		public function configure():void{
			
			// Map request signals to commands
			signalCommandMap.map(RequestConnectDevice).toCommand(ConnectDeviceCommand);
			signalCommandMap.map(RequestDisconnectDevice).toCommand(DisconnectDeviceCommand);
			signalCommandMap.map(RequestSendDatasToDevice).toCommand(SendDatasToDeviceCommand);
			signalCommandMap.map(RequestUpdateDeviceConnectionStatus).toCommand(UpdateDeviceConnectionStatusCommand);
			
			// Map notification signals
			injector.map(NotifyDeviceConnected).asSingleton();
			injector.map(NotifyDeviceDisconnected).asSingleton();
			injector.map(NotifyDatasReceivedFromDevice).asSingleton();
			injector.map(NotifyDatasSentToDevice).asSingleton();
			injector.map(NotifyErrorReceivedFromDevice).asSingleton();
			injector.map(NotifyDeviceConnectionStatusUpdated).asSingleton();
		}
		
	}
}